VERSION 5.00
Begin VB.Form frmAdminConsole_UserAccounts 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "User Accounts"
   ClientHeight    =   4335
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   5490
   HelpContextID   =   300
   Icon            =   "Admin Console User Accounts.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4335
   ScaleWidth      =   5490
   StartUpPosition =   1  'CenterOwner
   Begin VB.ListBox lstUsers 
      Height          =   3960
      ItemData        =   "Admin Console User Accounts.frx":27A2
      Left            =   180
      List            =   "Admin Console User Accounts.frx":27A4
      Sorted          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "List of users"
      Top             =   180
      Width           =   5115
   End
   Begin VB.Menu mnuTools 
      Caption         =   "Tools"
      Begin VB.Menu mnuTools_CreateNewAccount 
         Caption         =   "Create New Account"
      End
      Begin VB.Menu mnuTools_ChangeUserRights 
         Caption         =   "Change User Rights"
      End
      Begin VB.Menu mnuTools_DeleteAccount 
         Caption         =   "Delete Account"
      End
      Begin VB.Menu mnuTools_Bar1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Help 
         Caption         =   "Help"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuTools_Bar2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Close 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmAdminConsole_UserAccounts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************************
'*                         User Accounts                                    *
'*   Provides an interface to the Users table. Delegates the creation       *
'*   of new accounts and modification of user access rights to its two      *
'*   children forms. Carries out deletion on its own. Opens database in     *
'*   EXCLUSIVE for the duration of it execution only                        *
'*                                                                          *
'****************************************************************************


Option Explicit

Private Sub Form_Activate()
    UpdateListDisplay
End Sub

Private Sub UpdateListDisplay()
    Dim strCurrentUserName As String
    Dim intRowCounter As Integer
    
    'Store currently focused name if present
    If lstUsers.ListIndex <> -1 Then
        strCurrentUserName = lstUsers.List(lstUsers.ListIndex)
    End If
    
    'Clear listbox
    lstUsers.Clear
    
    'Reload listbox
    If rstUsers.RecordCount <> 0 Then
        rstUsers.MoveFirst
        Do
            lstUsers.AddItem rstUsers("User Name")
            rstUsers.MoveNext
        Loop Until rstUsers.EOF
    End If
    
    'If a name had been selected, reselect it if it is still in the list
    If lstUsers.ListCount <> 0 And strCurrentUserName <> "" Then
        For intRowCounter = 0 To lstUsers.ListCount - 1
            If lstUsers.List(intRowCounter) = strCurrentUserName Then
                lstUsers.ListIndex = intRowCounter
                Exit For
            End If
        Next
    End If
    
End Sub

Private Sub Form_Load()
    On Local Error GoTo errorHandler
    
    Const blnExclusiveMode = True
    Dim strDBpath As String
        
    'open databse in exclusive mode
    Set wspLevy = DBEngine.Workspaces(0)
    strDBpath = GetDatabasePath
    Set dbLevyOffice = wspLevy.OpenDatabase(strDBpath, blnExclusiveMode, False, ";pwd=25081982")
    Set rstUsers = dbLevyOffice.OpenRecordset("Users")

Exit Sub

errorHandler:
    MsgBox Err.Description, vbExclamation
    Unload Me
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    On Local Error Resume Next
    dbLevyOffice.Close
End Sub



Private Sub lstUsers_DblClick()
    Me.PopupMenu mnuTools
End Sub

Private Sub mnuTools_ChangeUserRights_Click()
    On Local Error Resume Next
    frmAdminConsole_UserAccounts_AccessRights.Show vbModal, Me
End Sub

Private Sub mnuTools_Click()
    
    'If nothing is selected disable menu items for changing rights and deleting accounts
    If lstUsers.ListIndex = -1 Then
        mnuTools_ChangeUserRights.Enabled = False
        mnuTools_DeleteAccount.Enabled = False
    Else
        mnuTools_ChangeUserRights.Enabled = True
        mnuTools_DeleteAccount.Enabled = True
    End If
    
    
End Sub

Private Sub mnuTools_Close_Click()
    Unload Me
End Sub

Private Sub mnuTools_CreateNewAccount_Click()
    frmAdminConsole_UserAccounts_CreateNew.Show vbModal, Me
    
End Sub

Private Sub mnuTools_DeleteAccount_Click()
    Dim strMsg As String
    Dim lngResponse As Long
    
    strMsg = "Are you sure you want to delete the account for "
    strMsg = strMsg & lstUsers.List(lstUsers.ListIndex)
    
    lngResponse = MsgBox(strMsg, vbQuestion + vbYesNo, "Delete User Account")
    If lngResponse = vbYes Then
        rstUsers.Index = "User Name Index"
        rstUsers.Seek "=", lstUsers.List(lstUsers.ListIndex)
        
        If rstUsers.NoMatch Then
            MsgBox "User Acount Not Found", vbCritical, "System Error"
        Else
            rstUsers.Delete
            MsgBox "Account successfully deleted.", vbInformation
        End If
    End If
    
    UpdateListDisplay
    
End Sub

Private Sub mnuTools_Help_Click()
    ShowHelpTopic 300
End Sub
