Attribute VB_Name = "DepositAnalysisSQL_CodeBase"
Option Explicit

Public Function getDurationDebits_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "SELECT DISTINCTROW " _
          & "       'Duration Debits' AS Description, " _
          & "       IIF(IsNull(Sum([Caution Fee Account Debits].[Amount])), 0, Sum([Caution Fee Account Debits].[Amount])) As Amount " _
          & "FROM   [Caution Fee Account Debits] " _
          & "WHERE  ((([Caution Fee Account Debits].[Transaction Date])>=[Start Date]) " _
          & "AND    ((DateValue([Caution Fee Account Debits].[Transaction Date]))<=DateValue([End Date]))) "
          
    getDurationDebits_DepositAnalysisSection = strSQL

End Function

Public Function getDurationCredits_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "       'Duration Credits' AS Description, " _
          & "       IIF(IsNull(Sum([Caution Fee Account Credits].[Amount])), 0, Sum([Caution Fee Account Credits].[Amount])) As Amount " _
          & "FROM   [Caution Fee Account Credits] " _
          & "WHERE  ((([Caution Fee Account Credits].[Transaction Date])>=[Start Date]) " _
          & "AND    ((DateValue([Caution Fee Account Credits].[Transaction Date]))<=DateValue([End Date]))) "
    
    getDurationCredits_DepositAnalysisSection = strSQL
    
End Function

Public Function getCurrentDebits_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "       'Current Total Debits' AS Description, " _
          & "       IIf(IsNull(Sum([Caution Fee Account Debits].[Amount])), 0, Sum([Caution Fee Account Debits].[Amount])) As Amount " _
          & "FROM   [Caution Fee Account Debits] "
          
    getCurrentDebits_DepositAnalysisSection = strSQL
              
End Function

Public Function getCurrentCredits_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "       'Current Total Credits' AS Description, " _
          & "       IIF(IsNull(Sum([Caution Fee Account Credits].[Amount])), 0, Sum([Caution Fee Account Credits].[Amount])) As Amount " _
          & "FROM   [Caution Fee Account Credits] " _
    
    getCurrentCredits_DepositAnalysisSection = strSQL
    
End Function

Public Function getCurrentShortfalls_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "      'Current Shortfalls' AS Description, " _
          & "      IIF(IsNull(Sum(Shortfall)), 0, Sum(Shortfall)) As Amount " _
          & "FROM " _
          & "(     SELECT [Student ID], " _
          & "             (  IIF(isNull([Total Credits]),0,[Total Credits]) " _
          & "                - IIF(isNull([Total Debits]),0,[Total Debits]) " _
          & "             )  as [Balance], " _
          & "             [Min Balance], " _
          & "             ([Min Balance]-[Balance]) as [Shortfall] " _
          & "      FROM " _
          & getBalancesStubSQL _
          & ") " _
          & "Where [Shortfall] > 0 "
          
    getCurrentShortfalls_DepositAnalysisSection = strSQL
    
End Function

Public Function getCurrentExcesses_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "      'Current Excesses' AS Description, " _
          & "      IIF(IsNull(Sum(Excess)), 0, Sum(Excess)) As Amount " _
          & "FROM " _
          & "(     SELECT [Student ID], " _
          & "             (  IIF(isNull([Total Credits]),0,[Total Credits]) " _
          & "                - IIF(isNull([Total Debits]),0,[Total Debits]) " _
          & "             )  as [Balance], " _
          & "             [Min Balance], " _
          & "             ([Balance]-[Min Balance]) as [Excess] " _
          & "       FROM " _
          & getBalancesStubSQL _
          & ") " _
          & "Where [Excess] > 0 "
    
    getCurrentExcesses_DepositAnalysisSection = strSQL
    
End Function

Public Function getCurrentNetPosition_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "     IIF( ([Signed Amount] > 0), 'Current Net Excess', 'Current Net Shorfall') AS Description, " _
          & "     IIF(([Signed Amount] < 0), [Signed Amount] * -1, [Signed Amount]) As Amount " _
          & "FROM         " _
          & "(            " _
          & "     SELECT   IIF(isNull(Sum(Excess)),0,Sum(Excess)) AS [Signed Amount] " _
          & "     FROM  " _
          & "     (        SELECT  [Student ID], " _
          & "                      (IIF(isNull([Total Credits]),0,[Total Credits]) - IIF(isNull([Total Debits]),0,[Total Debits]))  as [Balance], " _
          & "                      [Min Balance], " _
          & "                      ([Balance]-[Min Balance]) as [Excess] " _
          & "              FROM " _
          & getBalancesStubSQL _
          & "      ) " _
          & ") "
    
    getCurrentNetPosition_DepositAnalysisSection = strSQL

End Function

Private Function getBalancesStubSQL()
    Dim strSQL As String
    
    strSQL = "      ( " _
          & "             SELECT DISTINCTROW " _
          & "                        Students.[Student ID], " _
          & "                        (  SELECT  SUM([Caution Fee Account Credits].Amount) " _
          & "                           FROM    [Caution Fee Account Credits] " _
          & "                           WHERE   [Caution Fee Account Credits].[Student ID] = [Students].[Student ID] " _
          & "                        )   AS [Total Credits], " _
          & "                        (  SELECT  SUM([Caution Fee Account Debits].Amount) " _
          & "                           FROM    [Caution Fee Account Debits] " _
          & "                           WHERE   [Caution Fee Account Debits].[Student ID] = [Students].[Student ID] " _
          & "                        )  AS [Total Debits], " _
          & "                        (  SELECT  [Classes].[Minimum Balance] " _
          & "                           FROM    [Classes] " _
          & "                           WHERE   [Classes].[Class] = [Students].[Class] " _
          & "                        ) AS [Min Balance] " _
          & "             FROM Students, [Caution Fee Account Credits], [Caution Fee Account Debits] " _
          & "      ) "
        
        getBalancesStubSQL = strSQL
              
End Function

Public Function getCurrentTotalMinBals_DepositAnalysisSection() As String
    Dim strSQL As String
    
    strSQL = "UNION SELECT DISTINCTROW " _
          & "      'Current Total Min Balances' AS Description, " _
          & "      Sum([Min Balance]) As Amount " _
          & "FROM  " _
          & "(     SELECT DISTINCTROW " _
          & "            Students.[Student ID], " _
          & "            (  SELECT [Classes].[Minimum Balance]" _
          & "               FROM   [Classes] " _
          & "               WHERE  [Classes].[Class] = [Students].[Class] " _
          & "            ) AS [Min Balance] " _
          & "      FROM Students, [Classes] " _
          & "); "
    
    getCurrentTotalMinBals_DepositAnalysisSection = strSQL
    
End Function


