VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMailMerge_ProduceStandardLetters 
   Caption         =   "Producing Personalised Letters"
   ClientHeight    =   1635
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7650
   Icon            =   "Mail Merge Produce Standard Letters.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   1635
   ScaleWidth      =   7650
   StartUpPosition =   3  'Windows Default
   Begin RichTextLib.RichTextBox rtfLetter 
      Height          =   735
      Left            =   300
      TabIndex        =   2
      Top             =   900
      Visible         =   0   'False
      Width           =   2415
      _ExtentX        =   4260
      _ExtentY        =   1296
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"Mail Merge Produce Standard Letters.frx":030A
   End
   Begin MSComctlLib.ProgressBar barProgress 
      Height          =   435
      Left            =   120
      TabIndex        =   1
      Top             =   300
      Width           =   7395
      _ExtentX        =   13044
      _ExtentY        =   767
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   2940
      TabIndex        =   0
      Top             =   1020
      Width           =   1935
   End
End
Attribute VB_Name = "frmMailMerge_ProduceStandardLetters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Loading As Boolean

Private Sub cmdCancel_Click()
    'Give option to cancel print job in progress
    Printer.KillDoc
    Unload Me
End Sub

Private Sub Form_Load()
    barProgress.Value = 0
    Loading = True
End Sub

Private Sub Form_Activate()
    Dim blnPreview As Boolean
    Dim strUnformatedStdLetter As String
    Dim strFormatedStdLetter As String
    
    If Loading Then
        Loading = False
        
        'Store version of doc with and without formating.
        'Unformated version is used to ease syntax checking.
        'Formated version used for the actual output
        strUnformatedStdLetter = frmMailMerge_MasterForm.rtfMailMerge.Text
        strFormatedStdLetter = frmMailMerge_MasterForm.rtfMailMerge.TextRTF
        
        'this control provides the working area.
        rtfLetter.RightMargin = frmMailMerge_MasterForm.rtfMailMerge.RightMargin
        
        'Check if this is a preview session
        If frmMailMerge_MasterForm.mnuMailMerge_PreviewPersonalisedLetters.Checked = True Then
            blnPreview = True
        Else
            blnPreview = False
        End If
        
        Me.Caption = "Checking Standard Letter Syntax"
        If LetterSyntaxCorrect(strUnformatedStdLetter) Then
            barProgress.Value = 0
            If blnPreview Then
                Me.Caption = "Preparing Preview"
            Else
                Me.Caption = "Sending Letters To The Printer"
            End If
            Call PrintMergeLetters(strFormatedStdLetter, blnPreview)
        End If
        
        Unload Me
    End If

End Sub

Public Function LetterSyntaxCorrect(strUnformatedStdLetter) As Boolean
    'Check that the field names specifies actually exist and that the merge
    'fields have all been terminated properly
    
    Dim strFieldName As String
    Dim intFieldCount As Integer
    Dim lngCharCounter As Long
    
    
    'Go through the letter character by charcter
    For lngCharCounter = 1 To Len(strUnformatedStdLetter)
        If Mid(strUnformatedStdLetter, lngCharCounter, 1) = strFieldStartChar Then
            'Start of field name found. Try retrieving field name
            strFieldName = GetFieldName(lngCharCounter, strUnformatedStdLetter)
            If strFieldName <> "" Then
                'if retrived OK, then check that the field name exists
                If Not FieldNameVerified(strFieldName) Then
                    GoSub InvalidField
                End If
            Else
                GoSub InvalidField
            End If
        End If
        'update progress bar
        barProgress.Value = (lngCharCounter / Len(strUnformatedStdLetter)) * 100
        Me.Refresh
    Next
            
    LetterSyntaxCorrect = True

Exit Function
    
InvalidField:
    LetterSyntaxCorrect = False
    frmMailMerge_MasterForm.rtfMailMerge.SelStart = lngCharCounter - 1
    Exit Function
Return

End Function

Public Function GetFieldName(lngStart As Long, strUnformatedStdLetter) As String
    'Go through each character until an "end of field name" character is found
    Dim lngCurrentPosition As Long
    Dim strCharacter As String * 1
    Dim strFieldName  As String
        
    'Skip over the start of field character
    lngStart = lngStart + 1
    
    
    For lngCurrentPosition = lngStart To Len(strUnformatedStdLetter)
        strCharacter = Mid(strUnformatedStdLetter, lngCurrentPosition, 1)
        If strCharacter = strFieldEndChar Then
            'End of field found. Return it
            strFieldName = Mid(strUnformatedStdLetter, lngStart, lngCurrentPosition - lngStart)
            If strFieldName = "" Then
                MsgBox "Fieldname Not Specified", vbExclamation
            End If
            GetFieldName = strFieldName
            Exit For
        ElseIf strCharacter = strFieldStartChar Then
            'error: New field encountered before current one terminated
            MsgBox "New field encountered before the end of previous field", vbExclamation
            GetFieldName = ""
            Exit For
        ElseIf lngCurrentPosition = Len(strUnformatedStdLetter) Then
            'Reached end of document without finding end of field char
            MsgBox "End of field name not found", vbExclamation
            GetFieldName = ""
            Exit For
        End If
    Next
        
End Function

Public Function FieldNameVerified(strFieldName As String) As Boolean
    'Takes a supplied field name and then performs a case insensitive
    'test of it against the fields listed in the recordset to check if the
    'field name is valid
    Dim objField As Field
    Dim strMsg As String
    Dim blnFieldNameFound As Boolean
    
    For Each objField In rstQueryResults.Fields
        If TextTheSame(objField.Name, strFieldName) Then
            blnFieldNameFound = True
            Exit For
        End If
    Next
    
    If blnFieldNameFound Then
        FieldNameVerified = True
    Else
        strMsg = "The field name you specified is not among those available " _
               & "from the query specified. Chances are that you mispelt it. " _
               & "To avoid this in the future, use the 'Insert Merge Field' " _
               & "facility provided under the 'Mail Merge' menu."
        MsgBox strMsg, vbExclamation, "Missing Field: " & strFieldName
        FieldNameVerified = False
    End If
    
End Function


Public Sub PrintMergeLetters(strFormatedStdLetter As String, blnPreview As Boolean)
    
    'Text used to separate letters
    Const strSeparator = "{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss Times New Roman;}}{\colortbl\red0\green0\blue0;\red255\green0\blue0;}\deflang1033\pard\qc\plain\f2\fs28\cf1\b >>>>>>>>>>>>>>>>>>>>>>>>New Letter <<<<<<<<<<<<<<<<<<<<<<}"

    
    Dim objField As Field
    Dim strSeekText As String
    Dim strPreview As String
    
        
    Dim strFieldName As String
    Dim varFieldValue As Variant
    Dim intFieldType As Integer
    Dim strInsertion As String
    Dim lngNumberProcessed As Long
    
    'Force full population of recorset by jet engine
    rstQueryResults.MoveLast
    rstQueryResults.MoveFirst
    
    
    strPreview = ""
    Do
        'copy formatted letter into working area
        rtfLetter.TextRTF = strFormatedStdLetter
        
        'Take each field in the recordset, replace all of its occurances
        'in the std letter with the personalised detail.
        For Each objField In rstQueryResults.Fields
            'entry depends  on type
            strFieldName = objField.Name
            varFieldValue = rstQueryResults(strFieldName)
            intFieldType = rstQueryResults(strFieldName).Type
            
            If intFieldType = dbDate Then
                strInsertion = Format(varFieldValue, "d mmmm yyyy")
            ElseIf intFieldType = dbCurrency Then
                If TextTheSame(strFieldName, "Shortfall") Or TextTheSame(strFieldName, "Excess") Then
                    strInsertion = CurrencyFormat(varFieldValue, , moneyExcludeType)
                Else
                    strInsertion = CurrencyFormat(varFieldValue)
                End If
            ElseIf IsNumeric(varFieldValue) Then
                strInsertion = Str(varFieldValue)
            Else
                strInsertion = varFieldValue
            End If
            
            'Locate all instances of the field and replace them
            strSeekText = strFieldStartChar & strFieldName & strFieldEndChar
            Call EnterPersonalisedDetails(strSeekText, strInsertion)
        Next
        
        If blnPreview Then
            If frmMailMerge_Preview.rtfPreview.Text = "" Then
                'First letter processed, no need for separator.
                frmMailMerge_Preview.rtfPreview.TextRTF = rtfLetter.TextRTF
            Else
                'Add separator
                frmMailMerge_Preview.rtfPreview.SelStart = Len(frmMailMerge_Preview.rtfPreview.Text)
                frmMailMerge_Preview.rtfPreview.SelRTF = strNewLine & strNewLine
                frmMailMerge_Preview.rtfPreview.SelRTF = strSeparator
                frmMailMerge_Preview.rtfPreview.SelRTF = strNewLine & strNewLine
                
                'Add personalised letter
                frmMailMerge_Preview.rtfPreview.SelStart = Len(frmMailMerge_Preview.rtfPreview.Text)
                frmMailMerge_Preview.rtfPreview.SelRTF = rtfLetter.TextRTF
            End If
        Else
            'Actual perint session. Send letter to printer
            Call PrintRTF(rtfLetter, 600, 600, 600, 600, Printer)
            Printer.NewPage
        End If
        
        lngNumberProcessed = lngNumberProcessed + 1
        Me.Refresh
        barProgress.Value = (lngNumberProcessed / rstQueryResults.RecordCount) * 100
        rstQueryResults.MoveNext
    Loop Until rstQueryResults.EOF
                        
    If blnPreview Then
        Me.Caption = "Loading Preview"
        frmMailMerge_Preview.rtfPreview.SelStart = 0
        frmMailMerge_Preview.Caption = "Preview Personalised Letters (" _
                                     & Str(rstQueryResults.RecordCount) & " Letters)"
        frmMailMerge_Preview.Show vbModal, Me
    Else
        Printer.EndDoc
    End If
                
End Sub

Private Sub EnterPersonalisedDetails(strSearchText As String, strInsertion As String)
    'Uses the std replace routines to replace all the occurances of the field name
    'within the standard letter
    
    Const blnOptReset = True
    Dim lngLocation As Long
    Dim lngStartAt As Long
    Dim strBeingSearched As String
    
    lngStartAt = 1
    'Reset search so that it starts at the beginning
    Call Find_next(, , blnOptReset)
    
    Do
        strBeingSearched = rtfLetter.Text
        lngLocation = Embedded_in(lngStartAt, strBeingSearched, strSearchText, False, False)
        If lngLocation = 0 Then
            Exit Do
        Else
            lngStartAt = lngLocation + Len(strInsertion)
            With rtfLetter
                .SelStart = lngLocation - 1
                .SelLength = Len(strSearchText)
                .SelText = strInsertion
            End With
        End If
    Loop
    
    
End Sub

Private Function CurrencyFormat(ByVal Amount As Currency, Optional reqOmitSign As Boolean, Optional reqExcludeType As Boolean) As String
    'Default format includes both the sign and type
        
    Dim FractionPart As Single
    Dim IntegerPart As Long
    Dim FormatedText As String
    
    If IsMissing(reqOmitSign) Then reqOmitSign = False
    If IsMissing(reqExcludeType) Then reqExcludeType = False
    
    
    IntegerPart = Int(Abs(Amount))
    FractionPart = Abs(Amount) - IntegerPart
    
    If reqOmitSign Then
        FormatedText = Format(IntegerPart, "### ### ##0") _
                      & Format(FractionPart, ".00")
    Else
            FormatedText = Format(IntegerPart, "$ ### ### ##0") _
                      & Format(FractionPart, ".00")
    End If
    
    If Not (reqExcludeType) Then
        If Amount < 0 Then
            FormatedText = FormatedText + " DR"
        Else
            FormatedText = FormatedText + " CR"
        End If
    End If
    
    CurrencyFormat = FormatedText
    
End Function

